//+------------------------------------------------------------------+
//|                                                       Helper.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern double Lot=0.1;
extern bool Lock=false;
extern double SummaClose=0;
extern int Magic=1;
extern int TimeOpenSession=14;
extern int TimeCloseSession=23;
extern double Buy=0;
extern double Sell=0;
extern double BuyProfit=0;
extern double SellProfit=0;
extern double BuyLimit1=0;
extern double BuyLimit2=0;
extern double BuyLimit3=0;
extern double SellLimit1=0;
extern double SellLimit2=0;
extern double SellLimit3=0;
int ticket1=0,ticket2=0,ticket3=0,ticket4=0,ticket5=0,ticket6=0,
    ticket9=0,ticket10=0,ticket11=0,ticket12=0,ticket13=0,ticket14=0,
    ticket15=0,ticket16=0,ticket17=0,ticket18=0,ticket23=0,ticket24=0,
    endBuy,endSell,endLock;
bool ticket7,ticket8,ticket19,ticket20,ticket21,ticket22,ticket25,
     ticket26,ticket27;
double SummaProfitCloseSell,SummaProfitCloseBuy;    
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
SummaProfitCloseSell=0;
SummaProfitCloseBuy=0;   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
RefreshRates();
double StopLevel=MarketInfo( Symbol( ) , MODE_STOPLEVEL);
double SPREAD=MarketInfo( Symbol( ) , MODE_SPREAD);
int    digits=MarketInfo(Symbol( ),MODE_DIGITS);
int slippage=0;
int point20=0;
int point15=0;
if(digits==4 || digits==2)
   {
    slippage=2;
    point20=22;
    point15=15;
   }
if(digits==5 || digits==3)
   {
    slippage=20;
    point20=220;
    point15=150;
   }    

    int sumBUYLIMIT=0;
    int sumBUYSTOP=0;
    int sumSELLSTOP=0;
    int sumSELLLIMIT=0;
    double sumBUYLIMITLot=0;
    double sumBUYSTOPLot=0;
    double sumSELLSTOPLot=0;
    double sumSELLLIMITLot=0;
    double sumBuyLot=0;
    double sumSellLot=0;
    double sumBuy=0;
    double sumSell=0;
    double minBUYLIMIT=123;
    double minBUYSTOP=123;
    double minSELL=123;
    double minSELLSTOP=123;
    double minSELLLIMIT=123;    
    double maxBUY=0;
    double maxBUYSTOP=0;
    double maxBUYLIMIT=0;
    double maxSELLSTOP=0;
    double maxSELLLIMIT=0;
    double BuyMaxLot=0;
    double SellMaxLot=0;
    double BuyMinLot=123;
    double SellMinLot=123;
    double maxSELL=0;
    double minBUY=123;
    int SELLLIMITTicket=0;
    int BUYLIMITTicket=0;
    bool BuyLimits1=false;
    bool BuyLimits2=false;
    bool BuyLimits3=false;    
    bool SellLimits1=false;
    bool SellLimits2=false;
    bool SellLimits3=false;
    bool LockSellStop=false;
    bool LockBuyStop=false;    
    double sumBUYProfit=0;
    double sumSELLProfit=0;        
    int OrdTotal=OrdersTotal();
    for(int a=1; a<=OrdersTotal(); a++)          
        {
         if(OrderSelect(a-1,SELECT_BY_POS)==true)
            {
             if(OrderMagicNumber( )==Magic)
                {
             if(OrderType()==OP_BUYLIMIT)
                {
                 sumBUYLIMIT=sumBUYLIMIT+1;
                 sumBUYLIMITLot=sumBUYLIMITLot+OrderLots();
                 BUYLIMITTicket=OrderTicket( );
                 if(OrderOpenPrice( )<minBUYLIMIT)
                    {
                     minBUYLIMIT=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )>maxBUYLIMIT)
                    {
                     maxBUYLIMIT=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )== BuyLimit1)
                    {
                     BuyLimits1=true;
                    }
                 if(OrderOpenPrice( )== BuyLimit2)
                    {
                     BuyLimits2=true;
                    }
                 if(OrderOpenPrice( )== BuyLimit3)
                    {
                     BuyLimits3=true;
                    }                                                       
                }
             if(OrderType()==OP_BUYSTOP)
                {
                 sumBUYSTOP=sumBUYSTOP+1;
                 sumBUYSTOPLot=sumBUYSTOPLot+OrderLots();                             
                 if(OrderOpenPrice( )>maxBUYSTOP)
                    {
                     maxBUYSTOP=OrderOpenPrice( ); 
                    }
                 if(OrderOpenPrice( )<minBUYSTOP)
                    {
                     minBUYSTOP=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )==Buy)
                    {
                     LockBuyStop=true;
                    }       
                }
             if(OrderType()==OP_BUY)
                {
                 sumBuy=sumBuy+1;
                 sumBuyLot=sumBuyLot+OrderLots();
                 sumBUYProfit=sumBUYProfit+OrderProfit( );
                 if(OrderOpenPrice( )>maxBUY)
                    {
                     maxBUY=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )<minBUY)
                    {
                     minBUY=OrderOpenPrice( );
                    }   
                 if(OrderLots()>BuyMaxLot)
                    {
                     BuyMaxLot=OrderLots();
                    }
                 if(OrderLots()<BuyMinLot)
                    {
                     BuyMinLot=OrderLots();
                    }
                 if(OrderOpenPrice( )== BuyLimit1)
                    {
                     BuyLimits1=true;
                    }
                 if(OrderOpenPrice( )== BuyLimit2)
                    {
                     BuyLimits2=true;
                    }
                 if(OrderOpenPrice( )== BuyLimit3)
                    {
                     BuyLimits3=true;
                    }                                                                                                                  
                }
             if(OrderType()==OP_SELL)
                {
                 sumSell=sumSell+1;
                 sumSellLot=sumSellLot+OrderLots();
                 sumSELLProfit=sumSELLProfit+OrderProfit( ) ;
                 if(OrderOpenPrice( )<minSELL)
                    {
                     minSELL=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )>maxSELL)
                    {
                     maxSELL=OrderOpenPrice( );
                    }   
                 if(OrderLots()>SellMaxLot)
                    {
                     SellMaxLot=OrderLots();
                    }
                 if(OrderLots()<SellMinLot)
                    {
                     SellMinLot=OrderLots();
                    }
                 if(OrderOpenPrice( )== SellLimit1)
                    {
                     SellLimits1=true;
                    }
                 if(OrderOpenPrice( )== SellLimit2)
                    {
                     SellLimits2=true;
                    }
                 if(OrderOpenPrice( )== SellLimit3)
                    {
                     SellLimits3=true;
                    }                             
                }
             if(OrderType()==OP_SELLLIMIT)
                {
                 sumSELLLIMIT=sumSELLLIMIT+1;
                 sumSELLLIMITLot=sumSELLLIMITLot+OrderLots();
                 SELLLIMITTicket=OrderTicket( ) ;
                 if(OrderOpenPrice( )>maxSELLLIMIT)
                    {
                     maxSELLLIMIT=OrderOpenPrice( ); 
                    }
                 if(OrderOpenPrice( )<minSELLLIMIT)
                    {
                     minSELLLIMIT=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )== SellLimit1)
                    {
                     SellLimits1=true;
                    }
                 if(OrderOpenPrice( )== SellLimit2)
                    {
                     SellLimits2=true;
                    }
                 if(OrderOpenPrice( )== SellLimit3)
                    {
                     SellLimits3=true;
                    }                                           
                }
             if(OrderType()==OP_SELLSTOP)
                {
                 sumSELLSTOP=sumSELLSTOP+1;
                 sumSELLSTOPLot=sumSELLSTOPLot+OrderLots();
                 if(OrderOpenPrice( )>maxSELLSTOP)
                    {
                     maxSELLSTOP=OrderOpenPrice( ); 
                    }
                 if(OrderOpenPrice( )<minSELLSTOP)
                    {
                     minSELLSTOP=OrderOpenPrice( );
                    }
                 if(OrderOpenPrice( )==Sell)
                    {
                     LockSellStop=true;
                    }       
                }
                }                 
            }
        }
int Nbuy=0;
if(Buy!=0)
   {
    Nbuy=Nbuy+1;
   }
if(BuyLimit1!=0)
   {
    Nbuy=Nbuy+1;
   }
if(BuyLimit2!=0)
   {
    Nbuy=Nbuy+1;
   }
if(BuyLimit3!=0)
   {
    Nbuy=Nbuy+1;
   }
int Nbuylock=0;
Nbuylock=Nbuylock+sumBuy;
if(BuyLimit1!=0)
   {
    Nbuylock=Nbuylock+1;
   }
if(BuyLimit2!=0)
   {
    Nbuylock=Nbuylock+1;
   }
if(BuyLimit3!=0)
   {
    Nbuylock=Nbuylock+1;
   }
int Nselllock=0;
Nselllock=Nselllock+sumSell;
if(SellLimit1!=0)
   {
    Nselllock=Nselllock+1;
   }
if(SellLimit2!=0)
   {
    Nselllock=Nselllock+1;
   }
if(SellLimit3!=0)
   {
    Nselllock=Nselllock+1;
   }                   
int Nsell=0;   
if(Sell!=0)
   {
    Nsell=Nsell+1;
   }
if(SellLimit1!=0)
   {
    Nsell=Nsell+1;
   }
if(SellLimit2!=0)
   {
    Nsell=Nsell+1;
   }
if(SellLimit3!=0)
   {
    Nsell=Nsell+1;
   }                                     
if(a==OrdTotal+1)
   {   
//--------------------------------------------------------------------
double LockSellStopLot=0;
if(OrdersTotal()==Nbuy)
   {
    LockSellStopLot=sumBuyLot+sumBUYLIMITLot;
   }

if(endBuy==0 && OrdersTotal()==0 && Buy!=0 && iOpen( NULL, 0, 2)<Buy && iClose( NULL, 0, 2)<Buy && iClose( NULL, 0, 1)>Buy
   &&  (iClose( NULL, 0, 1)-Buy)<point15*Point && Hour()<TimeCloseSession && Hour()>=TimeOpenSession && 
   BuyProfit-Ask>point15*Point)
   {
    ticket1=OrderSend(Symbol(),OP_BUY,Lot,Ask,slippage,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket1<0)
       {
        Alert("    OP_BUY1(",GetLastError(),")");
        Sleep(2000);                     
        return(0);   
       }
   }
if(endBuy==0 && sumBuy>0 && sumSell==0 && BuyLimits1==false && Ask-BuyLimit1>=StopLevel*Point && BuyLimit1!=0)
   {
    ticket2=OrderSend(Symbol(),OP_BUYLIMIT,2*Lot,NormalizeDouble(BuyLimit1,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket2<0)
       {
        Alert("    OP_BUYLIMIT2(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(endBuy==0 && sumBuy>0 && sumSell==0 && BuyLimits2==false && Ask-BuyLimit2>=StopLevel*Point && BuyLimit2!=0)
   {
    ticket3=OrderSend(Symbol(),OP_BUYLIMIT,4*Lot,NormalizeDouble(BuyLimit2,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket3<0)
       {
        Alert("    OP_BUYLIMIT3(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(endBuy==0 && sumBuy>0 && sumSell==0 && BuyLimits3==false && Ask-BuyLimit3>=StopLevel*Point && BuyLimit3!=0)
   {
    ticket4=OrderSend(Symbol(),OP_BUYLIMIT,8*Lot,NormalizeDouble(BuyLimit3,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket4<0)
       {
        Alert("    OP_BUYLIMIT4(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
 Alert("LockSellStopLot=",LockSellStopLot);  
if(endBuy==0 && OrdersTotal()==Nbuy &&  LockSellStop==false && Sell!=0 && Bid-Sell>=StopLevel*Point)
   {
    ticket5=OrderSend(Symbol(),OP_SELLSTOP,LockSellStopLot,NormalizeDouble(Sell,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket5<0)
       {
        Alert("    OP_SELLSTOP5(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }  
//-------------------------------------------------------------------------------------
double LockBuyStopLot=0;
if(OrdersTotal()==Nsell)
   {    
    LockBuyStopLot=sumSellLot+sumSELLLIMITLot;
   } 

if(endSell==0 && OrdersTotal()==0 && Sell!=0 && iOpen( NULL, 0, 2)>Sell && iClose( NULL, 0, 2)>Sell && iClose( NULL, 0, 1)<Sell
   &&  (Sell-iClose( NULL, 0, 1))<point15*Point && Hour()<TimeCloseSession && Hour()>=TimeOpenSession && 
   Bid-SellProfit>point15*Point)
   {
    ticket10=OrderSend(Symbol(),OP_SELL,Lot,Bid,slippage,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket10<0)
       {
        Alert("    OP_SELL10(",GetLastError(),")");
        Sleep(2000);                     
        return(0);   
       }
   }
if(endSell==0 && sumSell>0 && sumBuy==0 && SellLimits1==false && SellLimit1-Bid>=StopLevel*Point && SellLimit1!=0)
   {
    ticket11=OrderSend(Symbol(),OP_SELLLIMIT,2*Lot,NormalizeDouble(SellLimit1,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket11<0)
       {
        Alert("    OP_SELLLIMIT11(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(endSell==0 && sumSell>0 && sumBuy==0 && SellLimits2==false && SellLimit2-Bid>=StopLevel*Point && SellLimit2!=0)
   {
    ticket12=OrderSend(Symbol(),OP_SELLLIMIT,4*Lot,NormalizeDouble(SellLimit2,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket12<0)
       {
        Alert("    OP_SELLLIMIT12(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   } 
if(endSell==0 && sumSell>0 && sumBuy==0 && SellLimits3==false && SellLimit3-Bid>=StopLevel*Point && SellLimit3!=0)
   {
    ticket13=OrderSend(Symbol(),OP_SELLLIMIT,8*Lot,NormalizeDouble(SellLimit3,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket13<0)
       {
        Alert("    OP_SELLLIMIT13(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(endSell==0 && OrdersTotal()==Nsell &&  LockBuyStop==false && Buy!=0 && Buy-Ask>=StopLevel*Point)
   {
    ticket6=OrderSend(Symbol(),OP_BUYSTOP,LockBuyStopLot,NormalizeDouble(Buy,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket6<0)
       {
        Alert("    OP_BUYSTOP6(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }    
//-------------------------------------------------------------------------------------------
if(Lock==false && sumBuy==1 && sumSell==0 && Ask-maxBUY>=point20*Point)
   {
    endBuy=1;
   }
if(Lock==false && sumBuy==1 && sumSell==0 && Ask>=BuyProfit)
   {
    endBuy=1;
   }   
if((Lock==false && sumBuy==0 &&  sumBUYLIMIT!=0) ||
   (Lock==false && sumBuy==0 && sumSELLSTOP!=0))
   {
    endBuy=1;
   }
if(Lock==false && sumBuy>1 && sumSell==0 && sumBUYProfit>SummaClose)
   {
    endBuy=1;
   }
if(Lock==false && sumSell==1 && sumBuy==0 && minSELL-Bid>=point20*Point)
   {
    endSell=1;
   }
if(Lock==false && sumSell==1 && sumBuy==0 && Bid<=SellProfit)
   {
    endSell=1;
   }      
if((Lock==false && sumSell==0 && sumSELLLIMIT!=0) ||
   (Lock==false && sumSell==0 && sumBUYSTOP!=0))
   {
    endSell=1;
   }
if(Lock==false && sumSell>1 && sumBuy==0 && sumSELLProfit>SummaClose)
   {
    endSell=1;
   }
if(Lock==false && sumBuy==0 && sumBUYLIMIT==0 && sumSELLSTOP==0)
   {
    endBuy=0;
   }
if(Lock==false && sumSell==0 && sumSELLLIMIT==0 && sumBUYSTOP==0)
   {
    endSell=0;
   }
if(endBuy==1)
   {
    for(int b=1; b<=OrdersTotal(); b++)          
        {
         if(OrderSelect(b-1,SELECT_BY_POS)==true)
            {
             if(OrderMagicNumber( )==Magic)
                {
                 if(OrderType()==OP_BUY)
                    {
                     ticket19=OrderClose( OrderTicket( ) , OrderLots( ) , Bid, slippage, CLR_NONE);                     
                     if(ticket19==FALSE)
                        {
                         Alert("   19(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                 if((sumBuy==0 && OrderType()==OP_BUYLIMIT) || 
                    (sumBuy==0 && OrderType()==OP_SELLSTOP))
                    {
                     ticket20=OrderDelete( OrderTicket( ) ,CLR_NONE);
                     if(ticket20==FALSE)
                        {
                         Alert("   20(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                }
            }
        }
   }
if(endSell==1)
   {
    for(int c=1; c<=OrdersTotal(); c++)          
        {
         if(OrderSelect(c-1,SELECT_BY_POS)==true)
            {
             if(OrderMagicNumber( )==Magic)
                {
                 if(OrderType()==OP_SELL)
                    {
                     ticket21=OrderClose( OrderTicket( ) , OrderLots( ) , Ask, slippage, CLR_NONE);                     
                     if(ticket21==FALSE)
                        {
                         Alert("   21(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                 if((sumSell==0 && OrderType()==OP_SELLLIMIT) ||
                    (sumSell==0 && OrderType()==OP_BUYSTOP))
                    {
                     ticket22=OrderDelete( OrderTicket( ) ,CLR_NONE);
                     if(ticket22==FALSE)
                        {
                         Alert("   22(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                }
            }
        }
   }                                                                                                                      
//-------------------------------  ----------------------------------------------
double ProfitCloseSell=0;
if(Lock==true && endLock==0 && sumBuyLot==sumSellLot && sumSell!=0 && iOpen( NULL, 0, 2)<Buy && iClose( NULL, 0, 2)<Buy && iClose( NULL, 0, 1)>Buy
   &&  (iClose( NULL, 0, 1)-Buy)<point15*Point && Hour()<TimeCloseSession && Hour()>=TimeOpenSession && 
   BuyProfit-Ask>point15*Point)
   {
    for(int d=1; d<=OrdersTotal(); d++)          
        {
         if(OrderSelect(d-1,SELECT_BY_POS)==true)
            {
             if(OrderMagicNumber( )==Magic)
                {
                 if(OrderType()==OP_SELL)
                    {
                     ticket7=OrderClose( OrderTicket( ) , OrderLots( ) , Ask, slippage, CLR_NONE);                     
                     if(ticket7==FALSE)
                        {
                         Alert("   7(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                     else  ProfitCloseSell=OrderProfit( ) ;  
                    }
                }
            }
        }
   }
   
SummaProfitCloseSell=SummaProfitCloseSell+ProfitCloseSell;
double ProfitCloseBuy=0;   
if(Lock==true && endLock==0 && sumBuyLot==sumSellLot && sumBuy!=0 && iOpen( NULL, 0, 2)>Sell && iClose( NULL, 0, 2)>Sell && iClose( NULL, 0, 1)<Sell
   &&  (Sell-iClose( NULL, 0, 1))<point15*Point && Hour()<TimeCloseSession && Hour()>=TimeOpenSession && 
   Bid-SellProfit>point15*Point)
   {
    for(int e=1; e<=OrdersTotal(); e++)          
        {
         if(OrderSelect(e-1,SELECT_BY_POS)==true)
            {
             if(OrderMagicNumber( )==Magic)
                {
                 if(OrderType()==OP_BUY)
                    {
                     ticket8=OrderClose( OrderTicket( ) , OrderLots( ) , Bid, slippage, CLR_NONE);                     
                     if(ticket8==FALSE)
                        {
                         Alert("   8(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                     else  ProfitCloseBuy=OrderProfit( ) ;   
                    }
                }
            }
        }
   }
SummaProfitCloseBuy=SummaProfitCloseBuy+ProfitCloseBuy;   
if(Lock==true &&  endLock==0 && sumBuy!=0 && sumSell==0 && BuyLimits1==false && Ask-BuyLimit1>=StopLevel*Point && BuyLimit1!=0)
   {
    ticket9=OrderSend(Symbol(),OP_BUYLIMIT,2*sumBuyLot,NormalizeDouble(BuyLimit1,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket9<0)
       {
        Alert("    OP_BUYLIMIT9(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(Lock==true &&  endLock==0 && sumBuy!=0 && sumSell==0 && BuyLimits2==false && Ask-BuyLimit2>=StopLevel*Point && BuyLimit2!=0)                   
   {
    ticket14=OrderSend(Symbol(),OP_BUYLIMIT,4*sumBuyLot,NormalizeDouble(BuyLimit2,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket14<0)
       {
        Alert("    OP_BUYLIMIT14(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(Lock==true &&  endLock==0 && sumBuy!=0 && sumSell==0 && BuyLimits3==false && Ask-BuyLimit3>=StopLevel*Point && BuyLimit3!=0)
   {
    ticket15=OrderSend(Symbol(),OP_BUYLIMIT,8*sumBuyLot,NormalizeDouble(BuyLimit3,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket15<0)
       {
        Alert("    OP_BUYLIMIT15(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }                                      
if(Lock==true &&  endLock==0 && sumBuy!=0 && sumSell==0 && OrdersTotal()==Nbuylock &&  LockSellStop==false && Sell!=0 && Bid-Sell>=StopLevel*Point)
   {
    ticket16=OrderSend(Symbol(),OP_SELLSTOP,LockSellStopLot,NormalizeDouble(Sell,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket16<0)
       {
        Alert("    OP_SELLSTOP16(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }  
if(Lock==true &&  endLock==0 && sumBuy==0 && sumSell!=0 && SellLimits1==false && SellLimit1-Bid>=StopLevel*Point && SellLimit1!=0)
   {
    ticket17=OrderSend(Symbol(),OP_SELLLIMIT,2*sumSellLot,NormalizeDouble(SellLimit1,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket17<0)
       {
        Alert("    OP_SELLLIMIT17(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(Lock==true &&  endLock==0 && sumBuy==0 && sumSell!=0 && SellLimits2==false && SellLimit2-Bid>=StopLevel*Point && SellLimit2!=0)
   {
    ticket18=OrderSend(Symbol(),OP_SELLLIMIT,4*sumSellLot,NormalizeDouble(SellLimit2,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket18<0)
       {
        Alert("    OP_SELLLIMIT18(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(Lock==true &&  endLock==0 && sumBuy==0 && sumSell!=0 && SellLimits3==false && SellLimit3-Bid>=StopLevel*Point && SellLimit3!=0)
   {
    ticket23=OrderSend(Symbol(),OP_SELLLIMIT,8*sumSellLot,NormalizeDouble(SellLimit3,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket23<0)
       {
        Alert("    OP_SELLLIMIT23(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if(Lock==true &&  endLock==0 && sumBuy==0 && sumSell!=0 && OrdersTotal()==Nselllock && LockBuyStop==false && Buy!=0 && Buy-Ask>=StopLevel*Point)
   {
    ticket24=OrderSend(Symbol(),OP_BUYSTOP,LockBuyStopLot,NormalizeDouble(Buy,Digits),0,0,0,NULL,Magic,0,CLR_NONE);
    if(ticket24<0)
       {
        Alert("    OP_BUYSTOP24(",GetLastError(),")");
        Sleep(2000);
        return(0);
       }
   }
if((Lock==true &&  sumBuy==0 && sumSell!=0 && sumSELLProfit+SummaProfitCloseBuy>=0) ||
   (Lock==true &&  sumBuy!=0 && sumSell==0 && sumBUYProfit+SummaProfitCloseSell>=0))
   {
    endLock=1;
   }
if(Lock==true && endLock==1)
   {
    for(int f=1; f<=OrdersTotal(); f++)          
        {
         if(OrderSelect(f-1,SELECT_BY_POS)==true)
            {
             if(OrderMagicNumber( )==Magic)
                {
                 if(OrderType()==OP_BUY)
                    {
                     ticket25=OrderClose( OrderTicket( ) , OrderLots( ) , Bid, slippage, CLR_NONE);                     
                     if(ticket25==FALSE)
                        {
                         Alert("   25(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                 if(OrderType()==OP_SELL)
                    {
                     ticket26=OrderClose( OrderTicket( ) , OrderLots( ) , Ask, slippage, CLR_NONE);                     
                     if(ticket26==FALSE)
                        {
                         Alert("   26(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                 if((OrderType()==OP_BUYLIMIT || OrderType()==OP_BUYSTOP) ||
                    (OrderType()==OP_SELLLIMIT || OrderType()==OP_SELLSTOP))
                    {
                     ticket27=OrderDelete( OrderTicket( ) ,CLR_NONE);
                     if(ticket27==FALSE)
                        {
                         Alert("   27(",GetLastError(),")"); 
                         Sleep(2000);
                         return(0);
                        }
                    }
                }
            }
        }
   }                       
                                                     
//-------------------------------------------------------------------------------------------
  } //    if(a==OrdTotal+1)
  if(OrdersTotal()==0)
     {
      SummaProfitCloseBuy=0;SummaProfitCloseSell=0;endLock=0;endSell=0;endBuy=0;
     } 
                                              
   return(0);
  }
//+------------------------------------------------------------------+